// udpserv2.cpp : main project file.
// must be linked with wsock32.lib and winmm.lib
//
// Elec 438, Spring 2007, Group 4
// Jeanne Guillory, Elliot Ng, Scott Novich, Ahmad Rahmati

#include "stdafx.h"


#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
#include <winsock.h>
#include <time.h>
#include <cstdlib>
#include <iostream>
#include <string>
#include <windows.h>
#include <mmsystem.h>
#include <sstream>

using namespace System;
using namespace System::ComponentModel;
using namespace System::Collections;
using namespace System::Data;
using namespace System::Runtime::InteropServices;
using std::string;

template<class T> std::string tostring(const T& source)
{
	std::ostringstream oss;
	oss << source;
	return oss.str();
};


#define SIZE 500
#define BUFFER_SIZE 4096


int main(array<System::String ^> ^args)
{
	// Server sending data
	if(args->Length ==4){
		printf("%s\n", args[0]);
		int port_number = int::Parse(args[0]);
		int datagrams = int::Parse(args[1]);
		double sleeptime = double::Parse(args[2]);
		char* tosend = (char*)(void*)Marshal::StringToHGlobalAnsi(args[3]+"\r\n");
		WSADATA w;								/* Used to open windows connection */
		int client_length;						/* Length of client struct */
		int bytes_received;						/* Bytes received from client */
		SOCKET sd;								/* Socket descriptor of server */
		struct sockaddr_in server;				/* Information about the server */
		struct sockaddr_in client;				/* Information about the client */
		char buffer[BUFFER_SIZE];				/* Where to store received data */
		struct hostent *hp;						/* Information about this computer */
		char host_name[256];					/* Name of the server */
		time_t current_time;					/* Current time */
		char send_buffer[SIZE] = "THE END\r\n";	/* To Close connection*/
		DWORD startTime, endTime, elapsedTime, newtime, nexttime, delay1;
		
		/* Open windows connection */
		if (WSAStartup(0x0101, &w) != 0)
		{
			printf("Could not open Windows connection.\n");
			exit(0);
		}

		/* Open a datagram socket */
		sd = socket(AF_INET, SOCK_DGRAM, 0);
		if (sd == INVALID_SOCKET)
		{
			printf("Could not create socket.\n");
			WSACleanup();
			exit(0);
		}

		/* Clear out server struct */
		memset((void *)&server, '\0', sizeof(struct sockaddr_in));

		/* Set family and port */
		server.sin_family = AF_INET;
		server.sin_port = htons(port_number);
		
		/* Get host name of this computer */
		gethostname(host_name, sizeof(host_name));
		hp = gethostbyname(host_name);

		/* Check for NULL pointer */
		if (hp == NULL)
		{
			printf("Could not get host name.\n");
			closesocket(sd);
			WSACleanup();
			exit(0);
		}
		
		/* Assign the address */
		server.sin_addr.S_un.S_un_b.s_b1 = hp->h_addr_list[0][0];
		server.sin_addr.S_un.S_un_b.s_b2 = hp->h_addr_list[0][1];
		server.sin_addr.S_un.S_un_b.s_b3 = hp->h_addr_list[0][2];
		server.sin_addr.S_un.S_un_b.s_b4 = hp->h_addr_list[0][3];
	
		/* Bind address to socket */
		if (bind(sd, (struct sockaddr *)&server, sizeof(struct sockaddr_in)) == -1)
		{
			printf("Could not bind name to socket.\n");
			closesocket(sd);
			WSACleanup();
			exit(0);
		}
		
		/* Loop and get data from clients */
		
		int whi = 1;
		int count =0;
		int bytes=0;
		while (whi)
		{
			/* Open a lo file to print information */
			FILE *log = fopen("serverlogdown.txt", "a");
			fprintf(log, "Downloading: \n");
			client_length = (int)sizeof(struct sockaddr_in);

			/* Receive bytes from client */
			bytes_received = recvfrom(sd, buffer, BUFFER_SIZE, 0, (struct sockaddr *)&client, &client_length);
			if (bytes_received < 0)
			{
				printf("Could not receive datagram.\n");
				closesocket(sd);
				WSACleanup();
				exit(0);
			}
			//Check for start request 
			if (strcmp(buffer, "START\r\n") == 0)
			{
				// Starting to send
				whi = 0;
				fprintf(log,"Beginning Time: ");
				startTime = timeGetTime();
				current_time = time(NULL);
				string str=ctime(&current_time);
				String^ s = gcnew String(str.c_str());
				char* stri = (char*)(void*)Marshal::StringToHGlobalAnsi(s);
				fprintf(log, stri);
				
				newtime = timeGetTime();
				fprintf(log, "Delay Times: ");
				while (count < datagrams)
				{
					count++;
					Sleep(sleeptime);
					client_length = (int)sizeof(struct sockaddr_in);
					if (sendto(sd, tosend, (int)strlen(tosend)+1, 0, (struct sockaddr *)&client, client_length) == -1)
					{
						printf("Error sending datagram.\n");
						closesocket(sd);
						WSACleanup();
						exit(0);
					}
					nexttime = timeGetTime();
					delay1 = abs(newtime - nexttime);
					str=tostring(delay1);
					s = gcnew String(str.c_str());
					stri = (char*)(void*)Marshal::StringToHGlobalAnsi(s);
		 			// Log delay time each loop
					fprintf(log, "%s ", stri);
					newtime = nexttime;
					bytes = bytes+ (int)strlen(tosend)+1;
				}
				
				endTime = timeGetTime();
				// Send end message 100 times to be sure to close the connection
				for(int i = 0; i<100;i++){
				Sleep(10);
					if (sendto(sd, send_buffer, (int)strlen(send_buffer) + 1, 0, (struct sockaddr *)&client, client_length) == -1)
					{
						closesocket(sd);
						WSACleanup();
					}
				}
				fprintf(log, "\nElapsed Time: ");
				
				elapsedTime = endTime - startTime;
				
				str=tostring(elapsedTime);
				s = gcnew String(str.c_str());
				stri = (char*)(void*)Marshal::StringToHGlobalAnsi(s);
		 		
				fprintf(log, stri);
				fprintf(log, " ms\nDatagrams Sent: %u\nBytes Sent: %u\n", datagrams, bytes);
				fclose(log);
				closesocket(sd);
				WSACleanup();
			}

		}
		return 0;
}

// Server receiving data
else if(args->Length == 1)
{
		
	int port_number = int::Parse(args[0]);
	WSADATA w;								/* Used to open Windows connection */
	SOCKET sd;								/* The socket descriptor */
	int server_length;						/* Length of server struct */
	time_t current_time;					/* Time received */
	struct hostent *hp;						/* Information about the server */
	struct sockaddr_in server;				/* Information about the server */
	struct sockaddr_in client;				/* Information about the client */
	char host_name[256];					/* Host name of this computer */
	int bytes_received;					/* Bytes received from client */
	char buffer[BUFFER_SIZE];			/* Where to store received data */
	DWORD startTime, endTime, elapsedTime;
	// Open Log file
	FILE *log = fopen("serverlogup.txt", "a");
	fprintf(log, "Uploading:\n");
	fprintf(log, "Beginning Time: ");
	long datagrams, bytes;
	datagrams = 0;
	bytes = 0;
	int whi = 1;
	startTime = timeGetTime();
	current_time = time(NULL);
	string str=ctime(&current_time);
	String^ s = gcnew String(str.c_str());
	char* stri = (char*)(void*)Marshal::StringToHGlobalAnsi(s);
	DWORD newtime, nexttime, delay1;
	newtime = 0;
	fprintf(log, stri);

	/* Open windows connection */
	if (WSAStartup(0x0101, &w) != 0)
	{
		printf("Could not open Windows connection.\n");
		exit(0);
	}

	/* Open a datagram socket */
	sd = socket(AF_INET, SOCK_DGRAM, 0);
	if (sd == INVALID_SOCKET)
	{
		printf("Could not create socket.\n");
		WSACleanup();
		exit(0);
	}

	/* Clear out server struct */
	memset((void *)&server, '\0', sizeof(struct sockaddr_in));

	/* Set family and port */
	server.sin_family = AF_INET;
	server.sin_port = htons(port_number);

	/* Get host name of this computer */
	gethostname(host_name, sizeof(host_name));
	hp = gethostbyname(host_name);

	/* Check for NULL pointer */
	if (hp == NULL)
	{
		printf("Could not get host name.\n");
		closesocket(sd);
		WSACleanup();
		exit(0);
	}
	
	/* Assign the address */
	server.sin_addr.S_un.S_un_b.s_b1 = hp->h_addr_list[0][0];
	server.sin_addr.S_un.S_un_b.s_b2 = hp->h_addr_list[0][1];
	server.sin_addr.S_un.S_un_b.s_b3 = hp->h_addr_list[0][2];
	server.sin_addr.S_un.S_un_b.s_b4 = hp->h_addr_list[0][3];


	/* Bind address to socket */
	if (bind(sd, (struct sockaddr *)&server, sizeof(struct sockaddr_in)) == -1)
	{
		printf("Could not bind name to socket.\n");
		closesocket(sd);
		WSACleanup();
		exit(0);
	}
	
	/* Loop and get data from clients */


	whi = 1;
	int count =0;
	bytes=0;
	while (whi)
	{
		int client_length;		
		client_length = (int)sizeof(struct sockaddr_in);

		/* Receive bytes from client */
		bytes_received = recvfrom(sd, buffer, BUFFER_SIZE, 0, (struct sockaddr *)&client, &client_length);
			
		if (bytes_received < 0)
		{
			printf("Could not receive datagram.\n");
			closesocket(sd);
			WSACleanup();
			exit(0);
		}
		// Check if the End message is received
		if (strcmp(buffer, "THE END\r\n") == 0)
		{
			whi = 0;
			fprintf(log, "\nElapsed Time: ");
			
			endTime = timeGetTime();
			elapsedTime = endTime - startTime;
			
			str=tostring(elapsedTime);
			s = gcnew String(str.c_str());
			stri = (char*)(void*)Marshal::StringToHGlobalAnsi(s);
	 		
			fprintf(log, stri);
			fprintf(log, " ms \nDatagrams received: %u \nBytes Received: %u \n", datagrams, bytes);
			fclose(log);

		}
		else
		{
			if(newtime == 0)
			{
				newtime = timeGetTime();
				fprintf(log, "Delay times: ");
				
			}
			else
			{
				nexttime = timeGetTime();
				delay1 = abs(newtime - nexttime);
				str=tostring(delay1);
				s = gcnew String(str.c_str());
				stri = (char*)(void*)Marshal::StringToHGlobalAnsi(s);
	 		
				fprintf(log, "%s ", stri);
				newtime = nexttime;
			}
			datagrams = datagrams +1;
			bytes = bytes+bytes_received;
		}
	}

	closesocket(sd);
	WSACleanup();
}
else{
	printf("usage downloading: udpserv2 port datagrams timetosleep messagetosend\nusage uploading: udpserv2 port");
	return 0;
}
}
