// udpcli2.cpp : main project file.
// must be linked with wsock32.lib and winmm.lib
// 
// Elec 438, Spring 2007, Group 4
// Jeanne Guillory, Elliot Ng, Scott Novich, Ahmad Rahmati

#include "stdafx.h"
#pragma once

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
#include <winsock.h>
#include <time.h>
#include <cstdlib>
#include <iostream>
#include <string>
#include <windows.h>
#include <mmsystem.h>
#include <sstream>

using namespace System;
using namespace System::ComponentModel;
using namespace System::Collections;
using namespace System::Data;
using namespace System::Runtime::InteropServices;
using std::string;

template<class T> std::string tostring(const T& source)
{
	std::ostringstream oss;
	oss << source;
	return oss.str();
};


#define SIZE 500
#define BUFFER_SIZE 4096

int main(array<System::String ^> ^args)
{
    WSADATA w;								/* Used to open Windows connection */
	SOCKET sd;								/* The socket descriptor */
	int server_length;						/* Length of server struct */
	time_t current_time;					/* Time */
	struct hostent *hp;						/* Information about the server */
	struct sockaddr_in server;				/* Information about the server */
	struct sockaddr_in client;				/* Information about the client */
	int a1, a2, a3, a4;						/* Server address components in xxx.xxx.xxx.xxx form */
	char host_name[256];					/* Host name of this computer */
	int bytes_received;					/* Bytes received from client */
	char buffer[BUFFER_SIZE];			/* Where to store received data */
	DWORD startTime, endTime, elapsedTime;
	
	//Client receiving data
	if (args->Length== 2)
	{
		int port_number = int::Parse(args[0]);
		char* ipadd = (char*)(void*)Marshal::StringToHGlobalAnsi(args[1]);
		
		/* get ip address */
		sscanf(ipadd, "%d.%d.%d.%d", &a1, &a2, &a3, &a4);
		
		/* Open windows connection */
		if (WSAStartup(0x0101, &w) != 0)
		{
			printf("Could not open Windows connection.\n");
			exit(0);
		}

		/* Open a datagram socket */
		sd = socket(AF_INET, SOCK_DGRAM, 0);
		if (sd == INVALID_SOCKET)
		{
			printf("Could not create socket.\n");
			WSACleanup();
			exit(0);
		}

		/* Clear out server struct */
		memset((void *)&server, '\0', sizeof(struct sockaddr_in));

		/* Set family and port */
		server.sin_family = AF_INET;
		server.sin_port = htons(port_number);

		/* Set server address */
		server.sin_addr.S_un.S_un_b.s_b1 = (unsigned char)a1;
		server.sin_addr.S_un.S_un_b.s_b2 = (unsigned char)a2;
		server.sin_addr.S_un.S_un_b.s_b3 = (unsigned char)a3;
		server.sin_addr.S_un.S_un_b.s_b4 = (unsigned char)a4;

		/* Clear out client struct */
		memset((void *)&client, '\0', sizeof(struct sockaddr_in));

		/* Set family and port */
		client.sin_family = AF_INET;
		client.sin_port = htons(0);

	
		/* Get host name of this computer */
		gethostname(host_name, sizeof(host_name));
		hp = gethostbyname(host_name);

		/* Check for NULL pointer */
		if (hp == NULL)
		{
			printf("Could not get host name.\n");
			closesocket(sd);
			WSACleanup();
			exit(0);
		}

		/* Assign the address */
		client.sin_addr.S_un.S_un_b.s_b1 = hp->h_addr_list[0][0];
		client.sin_addr.S_un.S_un_b.s_b2 = hp->h_addr_list[0][1];
		client.sin_addr.S_un.S_un_b.s_b3 = hp->h_addr_list[0][2];
		client.sin_addr.S_un.S_un_b.s_b4 = hp->h_addr_list[0][3];
	

		/* Bind local address to socket */
		if (bind(sd, (struct sockaddr *)&client, sizeof(struct sockaddr_in)) == -1)
		{
			printf("Cannot bind address to socket.\n");
			closesocket(sd);
			WSACleanup();
			exit(0);
		}
    
		// Open Log file to write to
		FILE *log = fopen("clientlogdown.txt", "a");	
		fprintf(log, "Downloading\n");
		fprintf(log, "Client IP address: %d.%d.%d.%d\n", client.sin_addr.S_un.S_un_b.s_b1,client.sin_addr.S_un.S_un_b.s_b2,client.sin_addr.S_un.S_un_b.s_b3,client.sin_addr.S_un.S_un_b.s_b4);
		
		/* Tranmsit data to start */
		char send_buffer[SIZE] = "START\r\n";/* Data to send */
		
		server_length = sizeof(struct sockaddr_in);
		if (sendto(sd, send_buffer, (int)strlen(send_buffer) + 1, 0, (struct sockaddr *)&server, server_length) == -1)
		{
			printf("Error transmitting data.\n");
			closesocket(sd);
			WSACleanup();
			exit(0);
		}
		fprintf(log, "Beginning Time: ");
		
		long datagrams, bytes;
		datagrams = 0;
		bytes = 0;
		int whi = 1;
		startTime = timeGetTime();
		current_time = time(NULL);
		string str=ctime(&current_time);
		String^ s = gcnew String(str.c_str());
		char* stri = (char*)(void*)Marshal::StringToHGlobalAnsi(s);
		DWORD newtime, nexttime, delay1;
		newtime = 0;
		fprintf(log, stri);
		while (whi)
		{
			server_length = (int)sizeof(struct sockaddr_in);

			/* Receive bytes from client */
			bytes_received = recvfrom(sd, buffer, BUFFER_SIZE, 0, (struct sockaddr *)&server, &server_length);
			
			if (bytes_received < 0)
			{
				printf("Could not receive datagram.\n");
				closesocket(sd);
				WSACleanup();
				exit(0);
			}

			// Check for End message
			if (strcmp(buffer, "THE END\r\n") == 0)
			{
				whi = 0;
				fprintf(log, "\nElapsed Time: ");
				
				endTime = timeGetTime();
				elapsedTime = endTime - startTime;
				
				str=tostring(elapsedTime);
				s = gcnew String(str.c_str());
				stri = (char*)(void*)Marshal::StringToHGlobalAnsi(s);
		 	
				fprintf(log, stri);
				fprintf(log, " ms \nDatagrams received: %u \nBytes Received: %u \n", datagrams, bytes);
				fclose(log);

			}
			else
			{
				if(newtime == 0)
				{
					newtime = timeGetTime();
					fprintf(log, "Delay times: ");
					
				}
				else
				{
					nexttime = timeGetTime();
					delay1 = abs(newtime - nexttime);
					str=tostring(delay1);
					s = gcnew String(str.c_str());
					stri = (char*)(void*)Marshal::StringToHGlobalAnsi(s);
		 			// log delay between packets
					fprintf(log, "%s ", stri);
					newtime = nexttime;
				}
				datagrams = datagrams +1;
				bytes = bytes+bytes_received;
			}
		}


		closesocket(sd);
		WSACleanup();
		printf("Done");
		return 0;
	}

	// Client is sending data
	else if (args->Length  == 5)
	{
		int port_number = int::Parse(args[0]);
		char* ipadd = (char*)(void*)Marshal::StringToHGlobalAnsi(args[1]);
		int datagrams = int::Parse(args[2]);
		double sleeptime = double::Parse(args[3]);
		char* tosend = (char*)(void*)Marshal::StringToHGlobalAnsi(args[4]+"\r\n");
		DWORD newtime, nexttime, delay1;
	
		/* Get Ip address */
		sscanf(ipadd, "%d.%d.%d.%d", &a1, &a2, &a3, &a4);
	
		/* Open windows connection */
		if (WSAStartup(0x0101, &w) != 0)
		{
			printf("Could not open Windows connection.\n");
			exit(0);
		}

		/* Open a datagram socket */
		sd = socket(AF_INET, SOCK_DGRAM, 0);
		if (sd == INVALID_SOCKET)
		{
			printf("Could not create socket.\n");
			WSACleanup();
			exit(0);
		}

		/* Clear out server struct */
		memset((void *)&server, '\0', sizeof(struct sockaddr_in));

		/* Set family and port */
		server.sin_family = AF_INET;
		server.sin_port = htons(port_number);

		/* Set server address */
		server.sin_addr.S_un.S_un_b.s_b1 = (unsigned char)a1;
		server.sin_addr.S_un.S_un_b.s_b2 = (unsigned char)a2;
		server.sin_addr.S_un.S_un_b.s_b3 = (unsigned char)a3;
		server.sin_addr.S_un.S_un_b.s_b4 = (unsigned char)a4;

		/* Clear out client struct */
		memset((void *)&client, '\0', sizeof(struct sockaddr_in));

		/* Set family and port */
		client.sin_family = AF_INET;
		client.sin_port = htons(0);

		
		/* Get host name of this computer */
		gethostname(host_name, sizeof(host_name));
		hp = gethostbyname(host_name);

		/* Check for NULL pointer */
		if (hp == NULL)
		{
			printf("Could not get host name.\n");
			closesocket(sd);
			WSACleanup();
			exit(0);
		}

		/* Assign the address */
		client.sin_addr.S_un.S_un_b.s_b1 = hp->h_addr_list[0][0];
		client.sin_addr.S_un.S_un_b.s_b2 = hp->h_addr_list[0][1];
		client.sin_addr.S_un.S_un_b.s_b3 = hp->h_addr_list[0][2];
		client.sin_addr.S_un.S_un_b.s_b4 = hp->h_addr_list[0][3];
		

		/* Bind local address to socket */
		if (bind(sd, (struct sockaddr *)&client, sizeof(struct sockaddr_in)) == -1)
		{
			printf("Cannot bind address to socket.\n");
			closesocket(sd);
			WSACleanup();
			exit(0);
		}
	    
		// Open log file 
		FILE *log = fopen("clientlogup.txt", "a");
		fprintf(log, "Uploading\n");
		fprintf(log, "Client IP address: %d.%d.%d.%d\n", client.sin_addr.S_un.S_un_b.s_b1,client.sin_addr.S_un.S_un_b.s_b2,client.sin_addr.S_un.S_un_b.s_b3,client.sin_addr.S_un.S_un_b.s_b4);
		
		/* Tranmsit data to start */
		char send_buffer[SIZE] = "THE END\r\n";
		
		/* Data to send */
		server_length = sizeof(struct sockaddr_in);
		
		fprintf(log,"Beginning Time: ");
		startTime = timeGetTime();
		current_time = time(NULL);
		string str=ctime(&current_time);
		String^ s = gcnew String(str.c_str());
		char* stri = (char*)(void*)Marshal::StringToHGlobalAnsi(s);
		fprintf(log, stri);
		int count = 0;
		int bytes = 0;
		newtime = timeGetTime();
		fprintf(log, "Delay Times: ");

		// Send Data
		while (count < datagrams)
		{
			count++;
			Sleep(sleeptime);
			if (sendto(sd, tosend, (int)strlen(tosend)+1, 0, (struct sockaddr *)&server, server_length) == -1)
			{
				printf("Error sending datagram.\n");
				closesocket(sd);
				WSACleanup();
				exit(0);
			}
			nexttime = timeGetTime();
			delay1 = abs(newtime - nexttime);
			str=tostring(delay1);
			s = gcnew String(str.c_str());
			stri = (char*)(void*)Marshal::StringToHGlobalAnsi(s);
 			// Log delay times
			fprintf(log, "%s ", stri);
			newtime = nexttime;
			bytes = bytes+ (int)strlen(tosend)+1;
		}
		endTime = timeGetTime();
		for( int i = 0; i<100; i++)
		{
			Sleep(10);
			if (sendto(sd, send_buffer, (int)strlen(send_buffer) + 1, 0, (struct sockaddr *)&server, server_length) == -1)
			{
				closesocket(sd);
				WSACleanup();
				
			}
		}
		fprintf(log, "\nElapsed Time: ");
		
		elapsedTime = endTime - startTime;
		
		str=tostring(elapsedTime);
		s = gcnew String(str.c_str());
		stri = (char*)(void*)Marshal::StringToHGlobalAnsi(s);
 		// Log total time
		fprintf(log, stri);
		fprintf(log, " ms\nDatagrams Sent: %u\nBytes Sent: %u\n", datagrams, bytes);
		fclose(log);
		closesocket(sd);
		WSACleanup();
			
	}
	else{
		printf("usage: udpcli2 port ipaddress\nusage: udpcli2 port serverip datagrams timetosleep message\n");
		return 0;
	}
}

